#include <stdio.h>
#include <stdlib.h>
#include "structures.h"
#include "case.h"
#include "personnage.h"
#include "deplacements.h"

/* Procdure de remplissage des cases  partir d'un fichier XML */
Case* Librairie_Cases(const char *filename){

return Remplir_Cases_log(filename);

}


/* Generation d'un fichier log decrivant le deroulement de la procedure d'aquisition des cases */
Case* Remplir_Cases_log(const char *filename)
{

    FILE* Cases_log = NULL;
    Cases_log = fopen("Cases_XML_log", "w");
    if (Cases_log != NULL)
    {
        fprintf(Cases_log,"Fichier decrivant le deroulement de la procedure d'aquisition des Cases\n\n");
        return Remplir_Cases(Cases_log, filename);
        fclose(Cases_log);
    }
    else
    {
        fprintf(stderr,"Impossible d'ouvrir le fichier Cases_XML_log");
        return 0;
    }
}




Case * init_case(Case * c,int x, int y, Type_Terrain *t){
    c->coord_x=x;
    c->coord_y=y;
    c->terrain=t;
    c->occupee=faux;
    return c;
}

int get_x(Case *c){
    return c->coord_x;
}

int get_y(Case *c){
    return c->coord_y;
}

boolean est_occupee(Case *c){
    return c->occupee;
}

boolean case_franchissable(Case *c){
    return terrain_franchissable(c->terrain);
}

void marquer_occupee(Case *c){
    if (c->occupee==vrai) printf("case dj occupe");
    c->occupee=vrai;
}

void marquer_libre(Case *c){
    if (c->occupee==faux) printf("case dj libre");
    c->occupee=faux;
}

Type_Terrain* get_terrain(Case *c){
    if (c->terrain==NULL){
        fprintf(stderr,"pas de terrain");
    }
    return c->terrain;
}

int init_carte(Carte* c,unsigned short int largeur, unsigned short int hauteur){
    int i,j,n;
    if (largeur*hauteur>TAILLE_MAX_CARTE){
        printf("erreur : taille maximum de la carte dpasse");
        return 1;
    }
    for (i=0;i<largeur;i++){
        for (j=0;j<hauteur;j++){
            init_case(c[n],i,j,NULL);
            n++;
        }
    }
    return 0;
}
